﻿Public Class Form1

    Private myDoubleClicked As Boolean

    'Handling the Load event by overwriting OnLoad.
    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)
        '...and set the window's title.
        Me.Text = "Doubleclick the window to show the graphic figure."
    End Sub

    'Draw graphic figure as soon as user doubleclicks into the window.
    Protected Overrides Sub OnDoubleClick(ByVal e As System.EventArgs)
        MyBase.OnDoubleClick(e)
        Dim g As Graphics = Graphics.FromHwnd(Me.Handle)
        DrawDemo(g)
        myDoubleClicked = True
    End Sub

    'We draw here:
    Public Sub DrawDemo(ByVal g As Graphics)

        'Clear the window's content.
        g.Clear(Color.White)

        'remember the actual width of the client area.
        Dim actualRememberedWidth = Me.ClientSize.Width
        Dim lineCounter = 0

        'Take every 5th pixel into account.
        For x = 0 To actualRememberedWidth Step 5

            'Firstly, draw line from upper left corner to bottom right.
            g.DrawLine(Pens.Black, 0, 0, x, Me.ClientSize.Height)

            'and then another one to cross diagonally.
            g.DrawLine(Pens.Black, actualRememberedWidth, _
                                0, actualRememberedWidth - x, _
                                Me.ClientSize.Height)

            'update line counter.
            lineCounter += 2
        Next

        'Inform in window title about the drawn line count.
        Me.Text = "Number of lines in this window: " & lineCounter
    End Sub

    'Being called, if content of the window was destroyed and has to get redrawn.
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)

        'Only if doubleclick already has happened.
        If myDoubleClicked Then
            '
            DrawDemo(e.Graphics)
        End If
    End Sub
End Class
