﻿Imports System.Windows.Media.Animation

Class Window1

    Private Sub Window1_SizeChanged(ByVal sender As Object, ByVal e As System.Windows.SizeChangedEventArgs) Handles Me.SizeChanged
        myCanvas.Children.Clear()

        'Calculate and store actual width of the canvas.
        Dim actualRememberedWidth = myCanvas.ActualWidth
        Dim lineCounter = 0

        'Take every 5th pixel into account.
        For x = 0 To actualRememberedWidth Step 5

            'Create new line object and set parameters.
            Dim aLine As New Line()
            aLine.Stroke = Brushes.Black
            aLine.X1 = 0
            aLine.Y1 = 0
            aLine.X2 = x
            aLine.Y2 = myCanvas.ActualHeight
            aLine.HorizontalAlignment = HorizontalAlignment.Left
            aLine.VerticalAlignment = VerticalAlignment.Center
            aLine.StrokeThickness = 1
            'Add to canvas.
            myCanvas.Children.Add(aLine)

            'Define diagonally running line.
            aLine = New Line()
            aLine.Stroke = Brushes.Black
            aLine.X1 = actualRememberedWidth
            aLine.Y1 = 0
            aLine.X2 = actualRememberedWidth - x
            aLine.Y2 = myCanvas.ActualHeight
            aLine.HorizontalAlignment = HorizontalAlignment.Left
            aLine.VerticalAlignment = VerticalAlignment.Center
            aLine.StrokeThickness = 1

            'Add also to canvas.
            myCanvas.Children.Add(aLine)

            'Update line count.
            lineCounter += 2
        Next

        Me.Title = "Number of lines in this window: " & lineCounter
    End Sub

    Private Sub Window1_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles Me.MouseDoubleClick
        Dim count = 0

        'This only works, since we have exclusively line objects on the canvas.
        For Each lineItem As Line In myCanvas.Children
            'Y2 property is being animated - hence the name.
            Dim Y2Animation As New DoubleAnimation(lineItem.ActualHeight, lineItem.ActualHeight / 2, TimeSpan.FromSeconds(3))

            Y2Animation.RepeatBehavior = RepeatBehavior.Forever

            Y2Animation.AutoReverse = True

            Y2Animation.BeginTime = New TimeSpan(500000 * count)

            'Start animation:
            lineItem.BeginAnimation(Line.HeightProperty, Y2Animation)
            count += 1
        Next
    End Sub
End Class
