Imports System.Text

Module StringsVsStringBuilder

    Sub Main()

        Dim locAmountElements As Integer
        Dim locAmountCharsPerElement As Integer
        Dim locVBStringElements As VBStringElements
        Dim locVBStringBuilderElements As VBStringBuilderElements

        'StringBuilderExamples()
        'Return

        Console.Write("Enter the string length of an element: ")
        locAmountCharsPerElement = Integer.Parse(Console.ReadLine)
        Console.Write("Enter a number of elements to be generated: ")

        locAmountElements = Integer.Parse(Console.ReadLine)
        Console.WriteLine()
        Console.WriteLine("Generating " & locAmountElements & " string elements with the String class...")

        Dim locTimeGauge = Stopwatch.StartNew

        locVBStringElements = New VBStringElements(locAmountElements, locAmountCharsPerElement)
        locTimeGauge.Stop()

        Console.WriteLine("Duration: " & locTimeGauge.ElapsedMilliseconds.ToString())
        locTimeGauge.Reset()
        Console.WriteLine("Generating " & locAmountElements & " string elements with the StringBuilder class...")
        locTimeGauge.Start()

        locVBStringBuilderElements = New VBStringBuilderElements(locAmountElements, locAmountCharsPerElement)
        locTimeGauge.Stop()

        Console.WriteLine("Duration: " & locTimeGauge.ElapsedMilliseconds.ToString())
        locTimeGauge.Reset()

        Console.WriteLine()
        Console.ReadLine()
    End Sub

    Sub StringBuilderExamples()
        'Declaration without parameters:
        Dim locSB As New StringBuilder

        'Declaration with capacity reservation
        locSB = New StringBuilder(1000)

        'Declaration from an existing string
        locSB = New StringBuilder("Created from a new string")

        'Declaration from string with the specification of a capacity to be reserved
        locSB = New StringBuilder("Created from string with capacity for more", 1000)
        locSB.Append(" - and this gets appended to the string")
        locSB.Insert(20, ">>this ends up somewhere in the middle<<")
        locSB.Replace("String", "StringBuilder")
        locSB.Remove(0, 4)

        'StringBuilder has finished building the string
        'Convert to string umwandeln
        Dim locString As String = locSB.ToString

        Console.WriteLine(locString)
        Console.ReadLine()
    End Sub

End Module

Public Class VBStringElements

    Private myStrElements() As String

    Sub New(ByVal AmountOfElements As Integer, ByVal AmountChars As Integer)

        ReDim myStrElements(AmountOfElements - 1)
        Dim locRandom As New Random(DateTime.Now.Millisecond)
        Dim locString As String

        For locOutCount As Integer = 0 To AmountOfElements - 1
            locString = ""
            For locInCount As Integer = 0 To AmountChars - 1
                Dim locIntTemp As Integer = Convert.ToInt32(locRandom.NextDouble * 52)
                If locIntTemp > 26 Then
                    locIntTemp += 97 - 26
                Else
                    locIntTemp += 65
                End If
                locString += Convert.ToChar(locIntTemp).ToString
            Next
            myStrElements(locOutCount) = locString
        Next
    End Sub

End Class

Public Class VBStringBuilderElements

    Private myStrElements() As String

    Sub New(ByVal AmountOfElements As Integer, ByVal AmountChars As Integer)

        ReDim myStrElements(AmountOfElements - 1)
        Dim locRandom As New Random(DateTime.Now.Millisecond)
        Dim locStringBuilder As StringBuilder

        For locOutCount As Integer = 0 To AmountOfElements - 1
            locStringBuilder = New StringBuilder(AmountChars)
            For locInCount As Integer = 0 To AmountChars - 1
                Dim locIntTemp As Integer = Convert.ToInt32(locRandom.NextDouble * 52)
                If locIntTemp > 26 Then
                    locIntTemp += 97 - 26
                Else
                    locIntTemp += 65
                End If
                locStringBuilder.Append(Convert.ToChar(locIntTemp))
            Next
            myStrElements(locOutCount) = locStringBuilder.ToString
        Next
    End Sub

End Class
