Module mdlMain

    Sub Main()

        'Instantiating with New and thus
        'creating storage for the Contact object
        'on the Managed Heap
        Dim objVarContact As New Contact With {
                    .LastName = "Halek",
                    .FirstName = "Sarah",
                    .ZIP = "99999",
                    .City = "Musterhausen"}

        'objVarContact2 points to the same object;
        'the referenced instance is the same!
        Dim objVarContact2 As Contact
        objVarContact2 = objVarContact

        'objVarContact3 point an object of the same kind;
        'the referenced instance is not exactly the same, but just the same kind!
        Dim objVarContact3 As New Contact With {
                    .LastName = "Halek",
                    .FirstName = "Sarah",
                    .ZIP = "99999",
                    .City = "Musterhausen"}

        'The proof:
        Console.WriteLine("The statement ""objVarContact equals objVarContact2"" is " & objVarContact.Equals(objVarContact2))

        Console.WriteLine("The statement ""objVarContact equals objVarContact3"" is " & objVarContact.Equals(objVarContact3))
        Console.WriteLine()

        'Alternatively with the IS keyword:
        Console.WriteLine("The statement ""objVarContact equals objVarContact2"" is " & (objVarContact Is objVarContact2))

        Console.WriteLine("The statement ""objVarContact equals objVarContact3"" is " & (objVarContact Is objVarContact3))

        Console.WriteLine()
        Console.WriteLine("Press key to exit")
        Console.ReadKey()
    End Sub

End Module

Class Contact

    Public Property LastName As String
    Public Property FirstName As String
    Public Property ZIP As String
    Public Property City As String

End Class

