Module Main

    Sub Main()
        'Declaration and definition of a regular string
        Dim locNormalString As String
        locNormalString = "When you hit your head against the wall "
        locNormalString = locNormalString + "you burn 150 calories."
        Console.WriteLine("Original string:")
        Console.WriteLine(locNormalString)

        'Deklaration und Definition eines Super-Strings
        Dim locSuperString As New SuperString(locNormalString)

        'SuperString function demo: Adding (appending) other strings
        Console.WriteLine()
        Console.WriteLine("'Adding' strings - append: 'Great, isn't it?'")
        locSuperString = locSuperString.Add(New SuperString(vbNewLine + " - Great, isn't it?"))
        Console.WriteLine(locSuperString.ToString)

        'Subtracting (removing) other strings
        Console.WriteLine()
        Console.WriteLine("'Subtracting' strings - remove: ', isn't it?'")
        locSuperString = locSuperString.Subtract(New SuperString(", isn't it"))
        Console.WriteLine(locSuperString.ToString)
        Console.WriteLine()

        'Subtract is overloadedalso works with the amount
        'of the last characters which need to be removed.
        Console.WriteLine("'Subtracting' stringssubtract the final 9 characters:")
        locSuperString = locSuperString.Subtract(9)
        Console.WriteLine(locSuperString.ToString)
        Console.WriteLine()

        'Multiplying strings
        Console.WriteLine("'Multiplying' strings:")
        locSuperString = locSuperString.Multiply(4)
        Console.WriteLine(locSuperString.ToString)
        Console.WriteLine()

        'Dividing stringsa bit more tricky
        locSuperString = New SuperString("The fortune cookie was invented in 1916 by George Jung, " & "an American pasta maker.")
        Console.WriteLine("'Dividing' strings:")
        Console.WriteLine(locSuperString.ToString)

        Dim locSuperStrings() As SuperString
        locSuperStrings = locSuperString.Divide(" "c)
        For Each locSString As SuperString In locSuperStrings
            Console.WriteLine(locSString.ToString)
        Next

        Console.WriteLine()
        Console.WriteLine("Press key to exit!")
        Console.ReadKey()

        TypeConvertingExperiments()
        ExperimentsForBooleanExpressions()
    End Sub

    Sub TypeConvertingExperiments()
        'Here you can use an implicit conversion (type extended)
        Dim aLong As Long, anInteger As Integer
        anInteger = 10
        aLong = anInteger


        'This requires an explicit conversion (because it's a conversion into a smaller type)
        aLong = 1000
        anInteger = CType(aLong, Integer)

        'This conversion must also be explicit
        Dim aDouble As Double, aString As String
        aString = "1,828,488,382.45"
        aDouble = CType(aString, Long)

    End Sub

    Sub ExperimentsForBooleanEXpressions()

        'Here implicit (type-extended) conversion is possible
        Console.Write("Would you like to enter more data (Yes, No):")

        Dim locSupStr As SuperString = Console.ReadLine
        If locSupStr Then
            Console.WriteLine("OK, go ahead!")
        Else
            Console.WriteLine("Well, then don't...")
        End If

        Console.WriteLine()
        Console.WriteLine("Press a key to exit!")
    End Sub

End Module

Public Structure SuperString
        Private myValue As String

    Public Sub New(ByVal Value As String)
        myValue = Value
    End Sub

    Public Overrides Function ToString() As String
        Return myValue
    End Function

    Public Function Add(ByVal differentString As SuperString) As SuperString
        Return New SuperString(myValue & differentString.ToString)
    End Function

    Public Function Subtract(ByVal differentString As SuperString) As SuperString
        Return New SuperString(myValue.Replace(differentString.ToString, ""))
    End Function

    Public Function Subtract(ByVal lastCharacter As Integer) As SuperString
        Try
            Return New SuperString(myValue.Substring(0, myValue.Length -
            (lastCharacter + 1)))
        Catch ex As Exception
            Return New SuperString(myValue)
        End Try
    End Function

    Public Function Multiply(ByVal amount As Integer) As SuperString
        'We are neat and avoid errors! ;-)
        If myValue Is Nothing Then
            Return Nothing
        End If

        If myValue = "" Or amount < 1 Then
            Return New SuperString("")
        End If

        'It's fastest with the StringBuilder!
        Dim locSB As New System.Text.StringBuilder

        'Just append the initial string as often
        'as 'amount' dictates.
        For c As Integer = 1 To amount
            locSB.Append(myValue)
        Next

        'and return!
        Return New SuperString(locSB.ToString)
    End Function

    Public Function Divide(ByVal separator As Char) As SuperString()

        Dim locStringArray As String()
        locStringArray = myValue.Split(New Char() {separator})

        Dim locSuperStringArray(locStringArray.Length - 1) As SuperString

        For z As Integer = 0 To locStringArray.Length - 1
            locSuperStringArray(z) = New SuperString(locStringArray(z))
        Next

        Return locSuperStringArray
    End Function


    'Operator +:
    Public Shared Operator +(ByVal sstring1 As SuperString, ByVal sstring2 As SuperString) As SuperString
        Return sstring1.Add(sstring2)
    End Operator
    Public Shared Operator +(ByVal sstring1 As SuperString, ByVal sstring2 As String) As SuperString
        Return sstring1.Add(New SuperString(sstring2))
    End Operator

    Public Shared Operator -(ByVal sstring1 As SuperString, ByVal sstring2 As SuperString) As SuperString
        Return sstring1.Subtract(sstring2)
    End Operator

    Public Shared Operator -(ByVal sstring1 As SuperString, ByVal anzahl As Integer) As SuperString
        Return sstring1.Subtract(anzahl)
    End Operator

    Public Shared Operator *(ByVal sstring1 As SuperString, ByVal anzahl As Integer) As SuperString
        Return sstring1.Multiply(anzahl)
    End Operator

    Public Shared Operator /(ByVal sstring1 As SuperString, ByVal trennzeichen As Char) As SuperString()
        Return sstring1.Divide(trennzeichen)
    End Operator

    Public Shared Operator <>(ByVal sString1 As SuperString, ByVal sString2 As SuperString) As Boolean
        Return (sString1.ToString <> sString2.ToString)
    End Operator

    Public Shared Operator =(ByVal sString1 As SuperString, ByVal sString2 As SuperString) As Boolean
        Return (sString1.ToString = sString2.ToString)
    End Operator

    Public Shared Operator <(ByVal sString1 As SuperString, ByVal sString2 As SuperString) As Boolean
        Return (sString1.ToString < sString2.ToString)
    End Operator

    Public Shared Operator >(ByVal sString1 As SuperString, ByVal sString2 As SuperString) As Boolean
        Return (sString1.ToString > sString2.ToString)
    End Operator

    Public Shared Widening Operator CType(ByVal normalString As String) As SuperString
        Return New SuperString(normalString)
    End Operator

    Public Shared Widening Operator CType(ByVal SuperString As SuperString) As String
        Return SuperString.ToString
    End Operator

    'Public Shared Narrowing Operator CType(ByVal normalString As String) As SuperString
    '    Return New SuperString(normalString)
    'End Operator

    Public Shared Operator IsTrue(ByVal sString As SuperString) As Boolean
        Dim locString As String = sString.ToString
        locString = locString.ToUpper
        Select Case locString
            Case "Y"
                Return True
            Case "YES"
                Return True
            Case "TRUE"
                Return True
            Case "CORRECT"
                Return True
            Case "SELECTED"
                Return True
            Case "PRESSED"
                Return True
            Case "ACCEPTED"
                Return True
            Case "CONFIRMED"
                Return True

            Case "JA"
                'And, to be thorough, the same in German:
                Return True
            Case "J"
                Return True
            Case "RICHTIG"
                Return True
            Case "WAHR"
                Return True
            Case "AUSGEWHLT"
                Return True
            Case "GEDRCKT"
                Return True
            Case "BESTTIGT"
                Return True
        End Select
        Return False
    End Operator


    Public Shared Operator IsFalse(ByVal sString As SuperString) As Boolean
        If sString Then
            Return False
        Else
            Return True
        End If
    End Operator
End Structure
