﻿Imports System.Drawing

'Provides the basic characteristics of a body
Public MustInherit Class BodyBase

    Private myColor As Color
    Private myPosition As Point

    MustOverride ReadOnly Property Volume() As Double

    Public Property Color() As Color
        Get
            Return myColor
        End Get
        Set(ByVal value As Color)
            myColor = value
        End Set
    End Property

    Public Property Position() As Point
        Get
            Return myPosition
        End Get
        Set(ByVal value As Point)
            myPosition = value
        End Set
    End Property
End Class


Public Class Cuboic
    Inherits BodyBase

    Private myLateralLength_a As Double
    Private myLateralLength_b As Double
    Private myLateralLength_c As Double

    Sub New(ByVal a As Double, ByVal b As Double, ByVal c As Double)
        myLateralLength_a = a
        myLateralLength_b = b
        myLateralLength_c = c
    End Sub

    Public Overrides ReadOnly Property Volume() As Double
        Get
            Return myLateralLength_a * myLateralLength_b * myLateralLength_c
        End Get
    End Property
End Class

Public Class Pyramid
    Inherits BodyBase

    Private mySurfaceArea As Double
    Private myHeight As Double

    Sub New(ByVal SurfaceArea As Double, ByVal Height As Double)
        mySurfaceArea = SurfaceArea
        myHeight = Height
    End Sub

    Public Overrides ReadOnly Property Volume() As Double
        Get
            Return (mySurfaceArea * myHeight) / 3
        End Get
    End Property
End Class
