Public Class AddressesKey

    Private myMatchcode As String
    Private myKeyValue As Integer

    Sub New(ByVal Matchcode As String)
        myKeyValue = Integer.Parse(Matchcode.Substring(4))
        myMatchcode = Matchcode
    End Sub

    'Required to find the correct
    'key during collisions.
    Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
        'If Not (TypeOf obj Is AddressesKey) Then
        ' Dim errAddressKey As New InvalidCastException("AddressesKey can only be compared to objects of the same type")
        ' Throw errAddressKey
        'End If
        Return myKeyValue.Equals(DirectCast(obj, AddressesKey).KeyValue)
    End Function

    'Required to "calculate" the index.
    Public Overrides Function GetHashcode() As Integer
        Return myKeyValue
    End Function

    Public Overrides Function ToString() As String
        Return myKeyValue.ToString
    End Function

    Public Property KeyValue() As Integer
        Get
            Return myKeyValue
        End Get
        Set(ByVal Value As Integer)
            myKeyValue = Value
        End Set
    End Property
End Class

Public Class Address

    'Constructorsets up a new instance
    Sub New(ByVal Matchcode As String, ByVal Name As String,
            ByVal FirstName As String, ByVal Zip As String, ByVal City As String)

        Me.Matchcode = Matchcode
        Me.Name = Name
        Me.FirstName = FirstName
        Me.ZIP = Zip
        Me.City = City
    End Sub

    Public Overridable Property Matchcode() As String
    Public Overridable Property Name() As String
    Public Overridable Property FirstName() As String
    Public Overridable Property ZIP() As String
    Public Overridable Property City() As String

    Public Overrides Function ToString() As String

        Return Matchcode + ": " + Name + ", " + FirstName + ", " + ZIP + " " + City

    End Function

    Public Shared Function RandomAddresses(ByVal Amount As Integer) As ArrayList
        Dim locArrayList As New ArrayList(Amount)
        Dim locRandom As New Random(Now.Millisecond)

        Dim locLastNames As String() = {"Heckhuis", "Lffelmann", "Thiemann", "Mller",
                    "Meier", "Tiemann", "Sonntag", "Ademmer", "Westermann", "Vllers",
                    "Hollmann", "Vielstedde", "Weigel", "Weichel", "Weichelt", "Hoffmann",
                    "Rode", "Trouw", "Schindler", "Neumann", "Jungemann", "Hrstmann",
                    "Tinoco", "Albrecht", "Langenbach", "Braun", "Plenge", "Englisch",
                    "Clarke"}

        Dim locFirstNames As String() = {"Jrgen", "Gabriele", "Uwe", "Katrin", "Hans",
                    "Rainer", "Christian", "Uta", "Michaela", "Franz", "Anne", "Anja",
                    "Theo", "Momo", "Katrin", "Guido", "Barbara", "Bernhard", "Margarete",
                    "Alfred", "Melanie", "Britta", "Jos", "Thomas", "Daja", "Klaus",
                    "Axel", "Lothar", "Gareth"}

        Dim locCities As String() = {"Wuppertal", "Dortmund", "Lippstadt", "Soest",
                    "Liebenburg", "Hildesheim", "Mnchen", "Berlin", "Rheda", "Bielefeld",
                    "Braunschweig", "Unterschleiheim", "Wiesbaden", "Straubing",
                    "Bad Waldliesborn", "Lippetal", "Stirpe", "Erwitte"}

        For i As Integer = 1 To Amount
            Dim locName, locFirstName, locMatchcode As String
            locName = locLastNames(locRandom.Next(locLastNames.Length - 1))
            locFirstName = locFirstNames(locRandom.Next(locLastNames.Length - 1))
            locMatchcode = locName.Substring(0, 2)
            locMatchcode += locFirstName.Substring(0, 2)
            locMatchcode += i.ToString("00000000")
            locArrayList.Add(New Address(
            locMatchcode,
            locName,
            locFirstName,
            locRandom.Next(99999).ToString("00000"),
            locCities(locRandom.Next(locCities.Length - 1))))
        Next

        Return locArrayList

    End Function

    Shared Sub OutputAddresses(ByVal Addresses As ArrayList)

        For Each Item As Object In Addresses
            Console.WriteLine(Item)
        Next

    End Sub

End Class