Module mdlMain

   Sub Main()
        Dim locFirstAddr As New Address("Cate", "Hora", "Musterstrae 24", "32132 Buchhausen")
        Dim locSecondAddr As New Address("Ramones", "Leenings", "Autorenstr. 22", "32132 Buchhausen")

        locFirstAddr.FriendsWith = New List(Of Address) From
                                {New Address("Joan", "Doe", "Autorenstr. 12", "32132 Buchhausen"),
                                locSecondAddr}

        locSecondAddr.FriendsWith = New List(Of Address) From
                                {New Address("Oli", "Hora", "Autorenstr. 22", "32132 Buchhausen")}
        'If you add this line, you create a circular reference

        'locSecondAddr.FriendsWith.Add(locFirstAddr)
        'Output original address
        Console.WriteLine("First address:")
        Console.WriteLine("==============")
        Console.WriteLine(locFirstAddr)

        Console.WriteLine("Second address:")
        Console.WriteLine("==============")
        Console.WriteLine(locSecondAddr)

        'Create copy
        Dim locAddrCopy As Address = DirectCast(ObjectCloner.
        DeepCopy(locFirstAddr), Address)
        Console.ReadLine()

    End Sub
End Module

<Serializable()> _
Public Class Address

    Private myCapturedOn As DateTime
    Private myCapturedBy As String

    Sub New(ByVal FirstName As String, ByVal Name As String, ByVal Street As String,
                    ByVal ZIPCity As String)

        'The contructor sets up all member data
        Me.Name = Name
        Me.FirstName = FirstName
        Me.Street = Street
        Me.ZIPCity = ZIPCity
        myCapturedOn = DateTime.Now
        myCapturedBy = Environment.UserName

    End Sub

    Public Property Name() As String
    Public Property FirstName() As String
    Public Property Street() As String
    Public Property ZIPCity() As String

    Public ReadOnly Property CapturedOn() As DateTime
        Get
            Return myCapturedOn
        End Get
    End Property

    Public ReadOnly Property CapturedBy() As String
        Get
            Return myCapturedBy
        End Get
    End Property

    Public Property FriendsWith() As List(Of Address)

    Public Overrides Function ToString() As String
        Dim locTemp As String
        locTemp = Name + ", " + FirstName + ", " + Street + ", " + ZIPCity + vbNewLine
        locTemp += "--- Friends with: ---" + vbNewLine
        For Each locAddr As Address In FriendsWith
            locTemp += " * " + locAddr.ToShortString() + vbNewLine
        Next
        locTemp += vbNewLine
        Return locTemp
    End Function

    Public Function ToShortString() As String
        Return Name + ", " + FirstName
    End Function

End Class