Module mdlMain

    Sub Main()
        Dim locAddrOriginal As New Address("Marcus", "Pusch", "Musterstrae 22", "59555 Lippstadt")
        Dim locAddrCopy As Address
        locAddrOriginal.FriendsWith = New List(Of Address) From {
                                        New Address("Ramona", "Leenings", "Autorstr. 33", "49595 Buchhausen"),
                                        New Address("Cate", "Hora", "Autorstr. 34", "49595 Buchhausen"),
                                        New Address("Gabriele", "Lffelmann", "Autorstr. 35",
                                        "49595 Buchhausen")}
        'Output original address
        Console.WriteLine("Original:")
        Console.WriteLine("=========")
        Console.WriteLine(locAddrOriginal)

        'Create copy
        With locAddrOriginal
            locAddrCopy = New Address(.FirstName, .Name, .Street, .ZIPCity)
            locAddrCopy.Name += " (copy)"
            locAddrCopy.FriendsWith = .FriendsWith
        End With
        'Output copy
        Console.WriteLine("Copy:")
        Console.WriteLine("=========")
        Console.WriteLine(locAddrCopy)
        'Changes to the original:
        CType(locAddrOriginal.FriendsWith(1), Address).Name = "Lffelmann-Beck"
        CType(locAddrOriginal.FriendsWith(2), Address).Name = "Lffelmann-Beck"
        'Copy after changes to the original
        Console.WriteLine("Copy after changes to the original:")
        Console.WriteLine("================================")
        Console.WriteLine(locAddrCopy)
        Console.ReadLine()

    End Sub

End Module

<Serializable()> _
Public Class Address

    Private myCapturedOn As DateTime
    Private myCapturedBy As String

    Sub New(ByVal FirstName As String, ByVal Name As String, ByVal Street As String,
                    ByVal ZIPCity As String)

        'The contructor sets up all member data
        Me.Name = Name
        Me.FirstName = FirstName
        Me.Street = Street
        Me.ZIPCity = ZIPCity
        myCapturedOn = DateTime.Now
        myCapturedBy = Environment.UserName

    End Sub

    Public Property Name() As String
    Public Property FirstName() As String
    Public Property Street() As String
    Public Property ZIPCity() As String

    Public ReadOnly Property CapturedOn() As DateTime
        Get
            Return myCapturedOn
        End Get
    End Property

    Public ReadOnly Property CapturedBy() As String
        Get
            Return myCapturedBy
        End Get
    End Property

    Public Property FriendsWith() As List(Of Address)

    Public Overrides Function ToString() As String
        Dim locTemp As String
        locTemp = Name + ", " + FirstName + ", " + Street + ", " + ZIPCity + vbNewLine
        locTemp += "--- Friends with: ---" + vbNewLine
        For Each locAddr As Address In FriendsWith
            locTemp += " * " + locAddr.ToShortString() + vbNewLine
        Next
        locTemp += vbNewLine
        Return locTemp
    End Function

    Public Function ToShortString() As String
        Return Name + ", " + FirstName
    End Function

End Class