﻿Module LinqToXml

    Sub Demo()
        ' Buildup sample data:
        Dim vehicles As New List(Of Vehicle)
        vehicles.Add(New Vehicle With {.LicencePlate = "MS-VB 2010", .Manufacturer = "Mercedes-Benz", .Load = New Vehicle.LoadsDescription With {.Amount = 10000, .Goods = "Salt"}})
        vehicles.Add(New Vehicle With {.LicencePlate = "MS-C# 2010", .Manufacturer = "Mack", .Load = New Vehicle.LoadsDescription With {.Amount = 20000, .Goods = "Peanuts"}})
        vehicles.Add(New Vehicle With {.LicencePlate = "MS-J# 2010", .Manufacturer = "Peterbilt", .Load = New Vehicle.LoadsDescription With {.Amount = 5000, .Goods = "Bobbleheads"}})

        ' XElemet daraus mit LINQ erstellen
        Dim Fleet = New XElement("Fleet", _
                                    From vcl In vehicles _
                                    Select New XElement("vehicle", _
                                                        New XElement("LicencePlate", vcl.LicencePlate), _
                                                        New XElement("Manufacturer", vcl.Manufacturer), _
                                                        New XElement("Goods", vcl.Load.Goods, New XAttribute("Amount", vcl.Load.Amount)) _
                                                        ))


        ' XElement mit LINQ und XML Literalen erstellen
        Dim Fleet2 = <Fleet>
                         <%= From fzg In vehicles _
                             Select <vehicle>
                                        <LicencePlate><%= fzg.LicencePlate %></LicencePlate>
                                        <Manufacturer><%= fzg.Manufacturer %></Manufacturer>
                                        <Goods Amount=<%= fzg.Load.Amount %>>
                                            <%= fzg.Load.Goods %>
                                        </Goods>
                                    </vehicle> _
                         %>
                     </Fleet>



        Console.WriteLine(Fleet2)
        Console.ReadKey()
    End Sub

End Module

''' <summary>
''' Helper class for Vehicles
''' </summary>
''' <reLicencePlates></reLicencePlates>
Public Class Vehicle

    Public Property LicencePlate() As String
    Public Property Load() As LoadsDescription
    Public Property Manufacturer() As String

    Public Class LoadsDescription
        Public Property Amount() As Double
        Public Property Goods() As String
    End Class
End Class

