﻿Imports System.Data.Objects

Module LazyEagerLoading

    Sub main()
        ManualLoading()
        EagerLoading()
    End Sub

    Sub ManualLoading()
        Dim awContext As New AWEntities()

        Dim suppliers = From supplier In awContext.Vendor _
                          Where supplier.Name.StartsWith("H") _
                          Order By supplier.Name

        'With this statement we can find out
        'which SQL text will be used.
        Console.WriteLine(CType(suppliers, ObjectQuery(Of Vendor)).ToTraceString)
        Console.WriteLine()

        For Each supplier In suppliers
            Console.WriteLine(supplier.AccountNumber & ": " & supplier.Name)
            Console.WriteLine(New String("="c, 70))

            If Not supplier.ProductVendor.IsLoaded Then
                supplier.ProductVendor.Load()

                'Deliever the products to each supplier
                For Each product In supplier.ProductVendor
                    If Not product.ProductReference.IsLoaded Then
                        product.ProductReference.Load()
                        Console.Write("ID:" & product.ProductID & " ")
                        Console.WriteLine("Name:" & product.Product.Name)
                    End If
                Next
                Console.WriteLine()
            End If

        Next

        Console.WriteLine()
        Console.WriteLine("Press key to exit.")
        Console.ReadKey()

    End Sub

    Sub EagerLoading()
        Dim awContext As New AWEntities()

        Dim lieferanten = From lieferant In awContext.Vendor.Include("ProductVendor.Product") _
                          Where lieferant.Name.StartsWith("H") _
                          Order By lieferant.Name

        'With this statement we can find out
        'which SQL text will be used.
        Console.WriteLine(CType(lieferanten, ObjectQuery(Of Vendor)).ToTraceString)
        Console.WriteLine()

        For Each lieferant In lieferanten
            Console.WriteLine(lieferant.AccountNumber & ": " & lieferant.Name)
            Console.WriteLine(New String("="c, 70))


            'Deliever the products to each supplier
            For Each produkt In lieferant.ProductVendor
                Console.Write("ID:" & produkt.ProductID & " ")
                Console.WriteLine("Name:" & produkt.Product.Name)
            Next
            Console.WriteLine()

        Next

        Console.WriteLine()
        Console.WriteLine("Press key to exit.")
        Console.ReadKey()
    End Sub



End Module